"""SphericalEnvelopeCentreDefinition"""

from __future__ import annotations

from enum import Enum
from typing import TYPE_CHECKING

from mastapy._private._internal.python_net import python_net_import

_SPHERICAL_ENVELOPE_CENTRE_DEFINITION = python_net_import(
    "SMT.MastaAPI.SystemModel.PartModel.Acoustics", "SphericalEnvelopeCentreDefinition"
)

if TYPE_CHECKING:
    from typing import Any, Type, TypeVar

    Self = TypeVar("Self", bound="SphericalEnvelopeCentreDefinition")
    CastSelf = TypeVar(
        "CastSelf",
        bound="SphericalEnvelopeCentreDefinition._Cast_SphericalEnvelopeCentreDefinition",
    )


__docformat__ = "restructuredtext en"
__all__ = ("SphericalEnvelopeCentreDefinition",)


class SphericalEnvelopeCentreDefinition(Enum):
    """SphericalEnvelopeCentreDefinition

    This is a mastapy class.

    Note:
        This class is an Enum.
    """

    @classmethod
    def type_(cls) -> "Type":
        return _SPHERICAL_ENVELOPE_CENTRE_DEFINITION

    CENTRE_OF_MODEL_EXTENTS = 0
    CENTRE_OF_SELECTED_PARTS_EXTENTS = 1


def __enum_setattr(self: "Self", attr: str, value: "Any") -> None:
    raise AttributeError("Cannot set the attributes of an Enum.") from None


def __enum_delattr(self: "Self", attr: str) -> None:
    raise AttributeError("Cannot delete the attributes of an Enum.") from None


SphericalEnvelopeCentreDefinition.__setattr__ = __enum_setattr
SphericalEnvelopeCentreDefinition.__delattr__ = __enum_delattr
